LeetCode:2789. 合并后数组中的最大元素(贪心 Java)

目录

[2789. 合并后数组中的最大元素](#2789. 合并后数组中的最大元素)

题目描述:

实现代码与解析:

贪心

原理思路:


2789. 合并后数组中的最大元素

题目描述:

给你一个下标从 0 开始、由正整数组成的数组 nums 。

你可以在数组上执行下述操作 任意 次:

  • 选中一个同时满足 0 <= i < nums.length - 1 和 nums[i] <= nums[i + 1] 的整数 i 。将元素 nums[i + 1] 替换为 nums[i] + nums[i + 1] ,并从数组中删除元素 nums[i] 。

返回你可以从最终数组中获得的 最大 元素的值。

示例 1:

复制代码
输入:nums = [2,3,7,9,3]
输出:21
解释:我们可以在数组上执行下述操作:
- 选中 i = 0 ,得到数组 nums = [5,7,9,3] 。
- 选中 i = 1 ,得到数组 nums = [5,16,3] 。
- 选中 i = 0 ,得到数组 nums = [21,3] 。
最终数组中的最大元素是 21 。可以证明我们无法获得更大的元素。

示例 2:

复制代码
输入:nums = [5,3,3]
输出:11
解释:我们可以在数组上执行下述操作:
- 选中 i = 1 ,得到数组 nums = [5,6] 。
- 选中 i = 0 ,得到数组 nums = [11] 。
最终数组中只有一个元素,即 11 。

提示:

  • 1 <= nums.length <= 105
  • 1 <= nums[i] <= 106

实现代码与解析:

贪心

java 复制代码
class Solution {
    public long maxArrayValue(int[] nums) {
        
        long res = 0;
        long  cur = 0;

        int n = nums.length;

        for (int i = n - 1; i >= 0; i--) {
            if (cur < nums[i]) {
                res = nums[i];
                cur = 0; // 重新开始计算
            }
            cur += nums[i];
        }

        return Math.max(res, cur);
    }
}

原理思路:

因为数组总和是不变的,想要获得最大值,那么就要尽可能的合并,条件中说右侧数大于左侧才能合并,那么我们就从后向前遍历,让右侧优先合并变大才能向前继续合并找到最大值。

如果遍历时,不能再合并,立即更新res为numsi,因为如果不能合并,说明左侧的单个数已经大于右侧合并的数,那么必然右侧不是最大值,重新开始计算即可。

最后要把cur和res取一个最大值,进行最后的比较。

相关推荐
金銀銅鐵7 分钟前
[Java] 展示增删元素时 LinkedList 的内部变化
java·后端·ai编程
布吉岛的石头42 分钟前
Java 程序员第 50 阶段3:数据工程:预训练语料清洗与去重
java·开发语言·人工智能·深度学习·transformer
大文说跨境1 小时前
防关联浏览器的指纹覆盖到什么程度:六类参数的实测与自检方法
java·指纹浏览器·tiktok运营
Carol06301 小时前
上肢及肩肘关节
java·服务器·数据库
yliucherish1 小时前
Log4Shell 复现实录:我读 OpenJDK 源码,发现两道防线的默认值竟然相反
java
维拉德2 小时前
Java新人第一次接打标需求:从抓包找接口到客户端展示
java
luobobo8962 小时前
支付回调验签连续失败三天,最后发现是网关的时间戳单位问题
java
BBmmo2 小时前
Java InputStream.read() 为什么返回 int?
java
Nuanyt2 小时前
LeetCode Hot100 刷题笔记 · 普通数组专题
java·笔记·算法·leetcode
cfm_29143 小时前
Leaf-segment号段模式
java